#!/usr/bin/perl
# ------------------------------------------------------------------------------
#  ident "@(#)nmen_container.pl 1.7 02/03/15 SMI"
# ------------------------------------------------------------------------------
#
#  Copyright 2001 Sun Microsystems, Inc. All rights reserved.
#
# ------------------------------------------------------------------------------
package main;

BEGIN {
	require "$ENV{NHINSTALL_LIB}/tools/lib/common.pl";
}
               

sub exit_cont_local_install {
    my ($admin_file, $answers_file, $proto_ip) = @_;

    unlink($admin_file);
	 unlink($answers_file);
    &remote_exec ( "$proto_ip", "$RUMOUNT /mnt" );
    &error("Unable to install CONTAINER local packages on NMENs" );
}


#-------------------------------------------------------------------------------
#
# Mount NHAS 2.0 directory from install-server and install CONTAINER local 
# installed pkg on all NMENs
#
#-------------------------------------------------------------------------------
sub cont_local_install_pkg {

  my $answers_file_name ="answers_local_cont_${proto_name}";
  my $answers_file ="${WORKING_DIR}/${answers_file_name}";

  
  # 
  # Create a pkgadd answers file
  #
  open(ANSWERS, ">$answers_file") ||
    &error("Unable to create $answers_file");
  
  print ANSWERS <<"FEO";

LDAP_ETC_SERVICE_PORT=7389
CSSC_ETC_SERVICE_PORT=667

FEO

  close(ANSWERS);

  install_nmen_pkg($NODE_ID, $ROOT_DIR, $PACKAGE_SUBDIR, $LOCAL_PACKAGES, $answers_file);
}

##################################################################################
#
#                               This is the main
#
##################################################################################

init_and_read_arg($0,
		  [ ROOT_DIR, PACKAGE_SUBDIR, LOCAL_PACKAGES, NODE_ROLE, WORKING_DIR ],
		  []);

# NMENs environment is only set on the first MEN
if (( $NODE_ID eq $MEN1_ID ) || ($NODE_ID eq $MASTER_ID)) {

  print_stage_node("Application Services installation for diskless") ;
  cont_local_install_pkg ();

}

# That's all folk!
exit(0);







