#!/usr/bin/perl
# ------------------------------------------------------------------------------
#  ident "@(#)common.pl 1.16 02/04/11 SMI"
# ------------------------------------------------------------------------------
#
#  Copyright 2001 Sun Microsystems, Inc. All rights reserved.
#
# ------------------------------------------------------------------------------

BEGIN {
	require "$ENV{NHINSTALL_LIB}/tools/lib/conf.pl";
}

#-----------------------------------------------------------
#
# general variable definition
#
#-----------------------------------------------------------

$NHAS_PRODUCT       = "Netra HA Suite 2.0" ;

$LOG                = \*STDERR;  # Default FD if <log-file> is not defined
$IN_LOGFILE         = FALSE ;
$LOGFILE_NAME       = "";
$VERBOSE            = 0;
$EXECDIR            = "" ;
$NODE_ID            = 0;
$SHARED_FS          = "/SUNWcgha/local/export/services" ;
$OPT_SUBDIR         = "ha_v1/opt" ;
$USR_SPECIFIC_SUBDIR= "usr_sparc.all" ;
$USR_SUBDIR         = "usr_sparc.all/usr" ;

#-----------------------------------------------------------
#
#  variables set by reading the arguments when
#  scripts are called
#
#-----------------------------------------------------------

$VERBOSE                   = 0;

$ROOT_DIR                  = "" ;
$JUMPSTART                 = "" ;
$SOLARIS_DIR               = "" ;
$JDK_DIR                   = "" ;
$WORKING_DIR               = "" ;
$SOLARIS_SUBDIR            = "" ;
$PACKAGE_SUBDIR            = "" ;
$PATCH_SUBDIR              = "" ;
$LDAP_SUBDIR               = "" ;
$JDK_SUBDIR                = "" ;

$LOCAL_PACKAGES            = "" ;
$SHARED_PACKAGES           = "" ;
$JDMK_PACKAGES             = "" ;
$JDK_PACKAGES              = "" ;
$SUPP_PACKAGES             = "" ;
$PATCH_NUMBER              = "" ;
$NODE_ROLE                 = "" ;
$TARGET_OS                 = "" ;
$PROFILE                   = "" ;
$ROUTER                    = "" ;
$LDAP_IPLANET              = "" ;
$PHASE                     = "" ;

$RECOVERY                  = "" ;

#-----------------------------------------------------------
#
#  argument description
#
#-----------------------------------------------------------

$ARGDESC   = 0;
$ARGSHORT  = 1;
$ARGLONG   = 2;

# same short or long form argument can appear several times (not in the same command of course)
# as the research is based on variable to be updated
#
# key: variable that will be updated
# 0: parameter description
# 1: short form of the argument
# 2: long form of the argument

%ARGLST = (
	   "ROOT_DIR"          => ["Directory mounted remotely" ,         "-R",    "--root"],
	   "JUMPSTART"         => ["Jumpstart directory",                 "-J",    "--jumpstart"],
	   "SOLARIS_DIR"       => ["Solaris distribution directory",      "-S",    "--solaris"],
	   "JDK_DIR"           => ["JDK distribution directory",          "-R",    "--jdkdir"],
	   "WORKING_DIR"       => ["Working directory",                   "-W",    "--workdir"],
	   "SOLARIS_SUBDIR"    => ["Solaris package sub-directory",       "-K",    "--solsubdir"],
	   "PACKAGE_SUBDIR"    => ["Package sub-directory (from root)",   "-P",    "--pkgsubdir"],
	   "PATCH_SUBDIR"      => ["Patch sub-directory (from root)",     "-C",    "--patchsubdir"],
	   "LDAP_SUBDIR"       => ["LDAP sub-directory (from root)",      "-L",    "--ldapsubdir"],
	   "JDK_SUBDIR"        => ["JDK Package sub-directory (from jdkdir)", "-P","--jdkpkgsubdir"],

	   "LOCAL_PACKAGES"    => ["Local packages",                      "-p",    "--pkg"],
	   "SHARED_PACKAGES"   => ["Shared packages",                     "-s",    "--shared"],
	   "JDK_PACKAGES"      => ["JDK packages",                        "-p",    "--jdkpkg"],
	   "JDMK_PACKAGES"     => ["JDMK packages",                       "-j",    "--jdmkpkg"],
	   "SUPP_PACKAGES"     => ["Additional packages",                 "-u",    "--upkg"],
	   "USRPLATFORM_PACKAGES"  => ["/usr/platform specific packages", "-u",    "--usrpkg"],
	   "PLATFORM_PACKAGES" => ["/platform specific packages",         "-p",    "--pkg"],
	   "PATCH_NUMBER"      => ["Patch number",                        "-m",    "--patch"],
           "NODE_ROLE"         => ["Node role (1, 2, m or v)",            "-n",    "--node_role"],
	   "TARGET_OS"         => ["Target OS",                           "-o",    "--os"],
	   "PROFILE"           => ["Path to installation profile",        "-f",    "--profile"],
	   "ROUTER"            => ["Router",                              "-r",    "--router"],
	   "LDAP_IPLANET"      => ["file tar.gz containing ldap Iplanet distrib", "-i", "--ldapiplanet"],
	   "PHASE"             => ["Phase of the installation",           "-p",    "--phase"],
	   "REBOOT"            => ["What to wait after reboot",           "-r",    "--reboot"],
	   );

#-----------------------------------------------------------
#
#  command definition
#
#-----------------------------------------------------------

@BINARIES=();
$CP="/usr/bin/cp"; @BINARIES=( @BINARIES, $CP );
$RCP="/usr/bin/rcp"; @BINARIES=( @BINARIES, $RCP );  
$KSH="/usr/bin/ksh"; @BINARIES=( @BINARIES, $KSH );
$SHARE="/usr/sbin/share"; @BINARIES=( @BINARIES, $SHARE );
$UNSHARE="/usr/sbin/unshare"; @BINARIES=( @BINARIES, $UNSHARE );
$RSH="/usr/bin/rsh";@BINARIES=( @BINARIES, $RSH );
$PING="/usr/sbin/ping";@BINARIES=( @BINARIES, $PING ); 
$CAT="/usr/bin/cat";@BINARIES=( @BINARIES, $CAT );
$PERL="/usr/bin/perl";@BINARIES=( @BINARIES, $PERL );
$PKILL="/usr/bin/pkill";@BINARIES=( @BINARIES, $PKILL );
$PWD="/usr/bin/pwd";@BINARIES=( @BINARIES, $PWD );
$NETSTAT="/usr/bin/netstat";@BINARIES=( @BINARIES,$NETSTAT );
$RM="/usr/bin/rm";@BINARIES=( @BINARIES,$RM );
$IFCONFIG="/usr/sbin/ifconfig";@BINARIES=( @BINARIES,$IFCONFIG );
$MV="/usr/bin/mv"; @BINARIES=( @BINARIES, $MV );
$FIND="/usr/bin/find"; @BINARIES=( @BINARIES, $FIND );

@REMOTE_BINARIES=();
$RMOUNT="/usr/sbin/mount";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RMOUNT);
$RUMOUNT="/usr/sbin/umount";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RUMOUNT);
$RPKGADD="/usr/sbin/pkgadd";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RPKGADD);
$RPATCHADD="/usr/sbin/patchadd";   @REMOTE_BINARIES=(@REMOTE_BINARIES, $RPATCHADD);
$RPATCHRM="/usr/sbin/patchrm";   @REMOTE_BINARIES=(@REMOTE_BINARIES, $RPATCHRM);
$RCHMOD="/usr/bin/chmod";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RCHMOD);
$RMKDIR="/usr/bin/mkdir";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RMKDIR);
$RPKGRM="/usr/sbin/pkgrm";    @REMOTE_BINARIES=(@REMOTE_BINARIES, $RPKGRM);
$RPKGINFO="/usr/bin/pkginfo"; @REMOTE_BINARIES=(@REMOTE_BINARIES, $RPKGINFO);
$RRM="/usr/bin/rm";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RRM);
$RDD="/usr/bin/dd";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RDD);
$RDHCPCONFIG="/usr/sbin/dhcpconfig";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RDHCPCONFIG);
$RPNTADM="/usr/sbin/pntadm";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RPNTADM);
$RDHTADM="/usr/sbin/dhtadm";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RDHTADM);
$RMV="/usr/bin/mv";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RMV);
$RLN="/usr/bin/ln";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RLN);
$RFIND="/usr/bin/find" ;@REMOTE_BINARIES=(@REMOTE_BINARIES, $RFIND) ;
$RCPIO="/usr/bin/cpio" ;@REMOTE_BINARIES=(@REMOTE_BINARIES, $RCPIO) ;
$RRSH="/usr/bin/rsh" ;@REMOTE_BINARIES=(@REMOTE_BINARIES, $RRSH) ;
$RSMOSSERVICE="/usr/sadm/bin/smosservice";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RSMOSSERVICE);
$RSMDISKLESS="/usr/sadm/bin/smdiskless";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RSMDISKLESS);
$RCOPY="/usr/bin/cp";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RCOPY);
$RECHO="/usr/bin/echo";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RECHO);
$RPKILL="/usr/bin/pkill";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RPKILL);
$RCAT="/usr/bin/cat";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RCAT);
$RRMDIR="/usr/bin/rmdir";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RRMDIR);
$RMETADB="/usr/sbin/metadb";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RMETADB);
$RMETAINIT="/usr/sbin/metainit";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RMETAINIT);
$RMETACLEAR="/usr/sbin/metaclear";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RMETACLEAR);
$RNEWFS="/usr/sbin/newfs";     @REMOTE_BINARIES=(@REMOTE_BINARIES, $RNEWFS);


#-----------------------------------------------------------
#
#  date
#
#-----------------------------------------------------------

sub getdate {
  my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime;
  $date = sprintf("%02.02d:%02.02d:%02.02d", $hour, $min, $sec) ;
  return $date ;
}

#-----------------------------------------------------------
#
#  argument testing
#
#  1: argument
#
#-----------------------------------------------------------

sub defined {
   my ($arg) = @_ ;
   return ( $arg || $arg eq "0" );
}

#===============================================================================
#
#  OUTPUT MANAGEMENT FUNCTIONS
#
#===============================================================================

#-----------------------------------------------------------
#
#   general output
#
#-----------------------------------------------------------

sub print_log {
  ($msg) = @_ ;

  print $LOG "$msg" ;
  if ($IN_LOGFILE eq TRUE) {
    # open, write and close to be sure all is ok even if there is a crash later
    open(LOGFILE, ">>$LOGFILE_NAME") or warning("Can't append log file $filename") ;
    print LOGFILE "$msg";
    close(LOGFILE);
  }
}

#-----------------------------------------------------------
#
#  display stage description message
#
#-----------------------------------------------------------

sub print_stage {
  my ($comment) = @_ ;

  my $date = getdate() ;
  print_log("$date $comment\n") ;
}

#-----------------------------------------------------------
#
#  display stage description message with node reference
#
#-----------------------------------------------------------

sub print_stage_node {
  my ($comment) = @_ ;

  my $nodename = build_node_name($NODE_ID, "") ;
  my $date = getdate() ;
  print_log("$date $comment (on node $nodename)\n") ;
}

#-----------------------------------------------------------
#
#  display recovery description message
#
#-----------------------------------------------------------

sub print_recovery_node {
  my ($comment) = @_ ;

  my $nodename = build_node_name($NODE_ID, "") ;
  my $date = getdate() ;
  print_log("$date Recovery after failure: $comment (on node $nodename)\n") ;
}

#-----------------------------------------------------------
#
#  display action description message
#
#-----------------------------------------------------------

sub print_action {
  my ($comment) = @_ ;

  my $date = getdate() ;
  print_log("$date   - $comment\n") ;
}

#-----------------------------------------------------------
#
#  display sub-action description message
#
#-----------------------------------------------------------

sub print_subaction {
  my ($comment) = @_ ;

  my $date = getdate() ;
  print_log("$date    . $comment\n") ;
}

#-----------------------------------------------------------
#
# error displays an error message and exit
#
# 1: error message
#
#-----------------------------------------------------------

sub error {
   my ($errorinfo) = @_;
   print_log("ERROR in $0. : $errorinfo\n") ;
   exit 1;
}

#------------------------------------------------------------
#
# warning displays a message
#
#   1: message
#
#------------------------------------------------------------

sub warning {
   my ($warninginfo) = @_;
   print_log("WARNING in $0: $warninginfo\n") ;
}

#------------------------------------------------------------
#
# trace displays a message if the trace level is reached
#
#   1: level
#   2: comment
#
#------------------------------------------------------------

sub trace {
   my ($level, $comment) =@_;
   if ( $level le $VERBOSE ) { 
      print_log("TRACE in $0 :$comment\n") ;
   }
}

#===============================================================================
#
#  DIRECTORY AND FILE MANAGEMENT
#
#===============================================================================

#------------------------------------------------------------
#
# Directory and file status
#
#------------------------------------------------------------

sub control_dir_is_readable {
   my ($directory) = @_;
   &error("Directory \"$directory\" does not exist or is not readable") 
   unless ( -d $directory && -x $directory  && -r $directory );   
}

sub control_dir_rxw_or_create {
   my ($directory) = @_;
   
   if ( -d $directory ) {
      &error("\"$directory\" directory exist but user don't have \"rwx\" rights on it") 
      unless ( -r $directory && -w $directory && -x $directory );
   } else {
      mkdir($directory,0777) || &error("Can not create \"$directory\" directory" );
   }
}

sub control_file_is_readable {
   my ($file) = @_;
   &error("File \"$file\" does not exist or is not readable") 
   unless ( -f $file && -r $file );
}

sub control_file_is_executable {
   my ($file) = @_;
   &error("File \"$file\" does not exist or is not executable") 
   unless ( -f $file && -x $file );
}

#------------------------------------------------------------
#
# Initialization
#
#------------------------------------------------------------

sub init {
  foreach $binary (@BINARIES) {
    &control_file_is_executable("$binary");
  }

  $EXECDIR=`/usr/bin/pwd`;
  chop($EXECDIR);
}

#===============================================================================
#
# COMMAND EXECUTION
#
#===============================================================================

#------------------------------------------------------------
#
#  prepare a command containing "`" by adding a "\" before
#
#  1: remote node
#  2: command
#
#------------------------------------------------------------

sub remote_exec_bis {
   my ($client, $command ) = @_ ;

   remote_exec($client, $command) ;
 }

#------------------------------------------------------------
#
#  execute a remote command and return the status result
#  if an error occurs, the output is displayed
#
#  1: remote node
#  2: command
#
#------------------------------------------------------------
sub remote_exec {
   my ($client, $command ) = @_ ;
   my $status = "OK";
   my $local_statusfile = "$WORKING_DIR/install-status.$$";
   my $remote_statusfile = "/tmp/install-status.$$";
   
   #
   # Initialize status on client side
   #
   open (LSTATUS,">$local_statusfile") || return 0;
   print LSTATUS "$status\n" ;
   close(LSTATUS);
      
   unless ( &exec_cmd( "$RCP $local_statusfile $client:$remote_statusfile" ) ) {  
        unlink($local_statusfile);
        &error ("Unable to initialize remote command status on client \"$client\" (remote node may be unreachable)");
   }
   
   unlink($local_statusfile);
      
   #
   # Execute  remote command
   #   
   
   my $output="";
   open ( REMOTEXEC, " $RSH -n $client \"$command || echo \$? > $remote_statusfile \" 2>&1|" )
     || error("Can not fork command: $RSH -n $client \"$command\"");
   while (<REMOTEXEC>) {
      chop();
      # trace if tracing has been set
      &trace(1,"$RSH -n $client \"$command\": $_");

      # capture outputs to displayed if an error occurs
      $output="$output  $_\n" ;

   }
   close (REMOTEXEC) || error ("Failure when executing: $RSH -n $client \"$command\" 2>&1 (remote node may be unreachable)"); 
   
   #
   # Retrieve execution status on client side
   #   
   unless ( &exec_cmd( "$RCP $client:$remote_statusfile $local_statusfile" ) ) {
     unlink($local_statusfile);
     &error ("Unable to retrieve remote command status on client \"$client\"");
   }
   
   unless ( open (LSTATUS,$local_statusfile) ) {
      unlink($local_statusfile);
      return 0;
   }
   chop($status=<LSTATUS>);
   close(LSTATUS);
   unlink($local_statusfile);
   
   unless ( $status eq "OK" ) {
     print_log("---------------------------------------------------------\n") ;
     &warning ( "remote command \"$command\" returned status: \"$status\" on client \"$client\""
	      );
     print_log($output) ;
     print_log("---------------------------------------------------------\n") ;
     return 0;
   }
	
}

#------------------------------------------------------------
#
#  execute a remote command without displaying remote errors
#  (error only if command can't be issued)
#
#  1: remote node
#  2: command
#
#------------------------------------------------------------

sub remote_exec_ignore {
   my ($client, $command ) = @_ ;

   #
   # Execute  remote command
   #   
   
   my $output="";
   open ( REMOTEXEC, " $RSH -n $client \"$command\" 2>&1|" )
     || error("Can not fork command: $RSH -n $client \"$command\" 2>$1") ;
   while (<REMOTEXEC>) {
      chop();
      # trace if tracing has been set
      &trace(1,"$RSH -n $client \"$command\": $_");
   }
   close (REMOTEXEC) || error ("Failure when executing: $RSH -n $client \"$command\" 2>&1 (remote node may be unreachable)");   
}

#------------------------------------------------------------
#
#  execute a local command and display the output:
#  . if there is an error
#  . if tracing option is set
#
#  1: command
#
#------------------------------------------------------------

sub exec_cmd {
    my ($command) = @_;

    @result = qx/$command 2>&1/;
  
    # in case of error, display output and exit
    if ( $? ne 0 ) {
      $status = $? / 256 ;
      print_log("-----------------------------------------------------------------------------\n");
      print_log("Error when executing: $command (status=$status)\n") ;
      foreach $line (@result)
	{
	  print_log("  $line\n") ;
	}
      print_log("-----------------------------------------------------------------------------\n");
       exit 1;
    }

   # if it's OK, display if tracing is required

    foreach $line (@result)
      {
	&trace( 1, $line);
      }
  
    return 1;
}

#------------------------------------------------------------
#
#  execute a local command and ignore the error:
#  if tracing option is set, outputs are displayed
#  1: command
#
#------------------------------------------------------------

sub exec_cmd_ignore {
    my ($command) = @_;

    @result = qx/$command 2>&1/;

   # if it's OK, display if tracing is required

    foreach $line (@result)
      {
	&trace( 1, $line);
      }
  
    return 1;
}

#-------------------------------------------------------------------------------
#
# remote_mount
#
# . dismount the mounting point (to prevent errors if it is already mounted)
# . mount the remote directory on the mounting point
#
# 1: node IP
# 2: server IP
# 2: exported directory to mount
# 3: mounting point
#
#-------------------------------------------------------------------------------

sub remote_mount
  {
    my ($node_ip, $server_ip, $exported, $mountpoint) = @_ ;

    remote_exec_ignore("$node_ip", "$RUMOUNT $mountpoint") ;
    &remote_exec ( "$node_ip", "$RMOUNT -o retry=0 -f nfs $server_ip:$exported $mountpoint" ) || 
      &error ( "Unable to NFS mount $exported" );
  }

#===============================================================================
#
#    MOUNT/UMOUNT FOR OPTIMIZED DISKLESS INSTALLATION
#
#===============================================================================

#-------------------------------------------------------------------------------
#
# mount required mounting points
# the current status of these mounting points is unknown (after a recovery)
# they are unmounted (without taking into account errors) and re-mounted
#
#-------------------------------------------------------------------------------
sub mount_nmen {
   my ($node_id) = @_;
   my $node_ip   ="${SUBNET0}.${CLUSTER}.${SUBNET1}.${node_id}";
   
   if ($ENV{OPTIMIZED_INSTALL} eq "YES") {
     # ignore errors
     remote_exec_ignore("$node_ip", "$RUMOUNT $SLICE_EXPORT") ;
     remote_exec_ignore("$node_ip", "$RUMOUNT $SLICE_SUNWCGHA");

     # reboot has been partial so mounting point are not present

     # ignore errors when called from recovery mechanism (they may be still
     # used so error "busy" may occurs
     if ($RECOVERY ne "") {

       # this is the recovery

       # if SVM is used, /export must be mounted on the physical because
       # of a smosservices bug
       if ($USE_SVM eq "YES") {
	 slice_search(mounting_point, $SLICE_EXPORT, \$idx) ;
	 remote_exec_ignore( "$node_ip", "$RMOUNT /dev/dsk/$SLICE_LIST[$idx]{name} $SLICE_EXPORT") ||
	   error ( "Unable to mount $SLICE_EXPORT on /dev/dsk/$SLICE_LIST[$idx]{name}");
	 
       } else { 
	 remote_exec_ignore("$node_ip", "$RMOUNT $SLICE_EXPORT") ;
       }
       
       remote_exec_ignore("$node_ip", "$RMOUNT $SLICE_SUNWCGHA");

     } else {

       # normally not used but maintain in case

       if ($USE_SVM eq "YES") {
	 slice_search(mounting_point, $SLICE_EXPORT, \$idx) ;
	 remote_exec_ignore( "$node_ip", "$RMOUNT /dev/dsk/$SLICE_LIST[$idx]{name} $SLICE_EXPORT") ||
	   error ( "Unable to mount $SLICE_EXPORT on /dev/dsk/$SLICE_LIST[$idx]{name}");
	 
       } else { 
	 remote_exec_ignore("$node_ip", "$RMOUNT $SLICE_EXPORT") ;
       }
       remote_exec_ignore("$node_ip", "$RMOUNT $SLICE_SUNWCGHA");

     }
   }
}


#===============================================================================
#
#    PACKAGES MANAGEMENT ROUTINES
#
#===============================================================================


#-------------------------------------------------------------------------------
#
#  clean up when a package installation fails
#
#  1: admin file
#  2: answers file
#  3: node ip address
#
#-------------------------------------------------------------------------------

sub exit_install_pkg {
  
  my ($admin_file, $answers_file, $node_ip) = @_;

  unlink($admin_file);
  if ($answers_file ne "") {
    unlink($answers_file) ;
  }
  &remote_exec ( "$node_ip", "$RUMOUNT /mnt" );
  &error("Unable to install packages" );
}

#-------------------------------------------------------------------------------
#
#  remove a package from a MEN (errors are ignored)
#
#  1: Node ID
#  2: Package list
#  3: installed on local (LOCAL) or shared (SHARED) directory
#
#-------------------------------------------------------------------------------

sub remove_men_pkg {

  my ($nodeid, $package_list, $option) = @_;

  my $node_ip     = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${nodeid}";
  my $server_ip   = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${SERVER_NODE}";
  my $admin_file  = "$WORKING_DIR/admin";
  
  #
  #  configure settings depending installation is shared or not
  #
  my $basedir = "" ;
  my $optcmd  = "" ;
  my $adj     = "" ;
  
  if ($option eq "LOCAL") {

    $basedir = "default" ;
    $optcmd  = "" ;
    $adj     = "local" ;

  } elsif ($option eq "SHARED") {

    $basedir = "/$OPT_SUBDIR" ;
    $optcmd  = "-R $SHARED_FS" ;
    $adj     = "shared" ;

  } elsif ($option eq "SHARED_USR") {
    $loc = "/export/Solaris_8" ;
    if ($TARGET_OS eq "solaris_9") {
      $loc = "/export/Solaris_9" ;
    }
    $basedir = "/$USR_SUBDIR" ;
    $optcmd  = "-R $loc" ;
    $adj     = "user" ;

  } elsif ( $option eq "USR_SPECIFIC") {

    $loc = "/export/Solaris_8" ;
    if ($TARGET_OS eq "solaris_9") {
      $loc = "/export/Solaris_9" ;
    }
    $basedir = "/$USR_SPECIFIC_SUBDIR" ;
    $optcmd  = "-R $loc" ;
    $adj     = "usr-specific" ;

  } else {
    error("Invalid option ($option) for MEN package removing") ;
  }
  
  print_action("Removing $adj packages: $package_list ...") ;

  # 
  # Create a pkgadd admin file
  #
  open(ADMIN, ">$admin_file") ||
    &error("Unable to create $admin_file");

   print ADMIN <<"FEO";
	
mail=
instance=overwrite
partial=nocheck
runlevel=quit
idepend=quit
rdepend=nocheck
space=quit
setuid=nocheck
conflict=nocheck
action=nocheck
basedir=$basedir

FEO


  close(ADMIN);
  
  #
  # copy the admin file on the remote node
  #
  exec_cmd( "$RCP $admin_file $node_ip:/tmp/admin" ) ||
    &error ( "Unable to copy $admin_file on $node_ip:/tmp/admin") ;
  
  #
  # remove the packages in the reverse order
  #
  # do not display error
  my @list = split(" ",$package_list) ;
  for (my $i = (scalar(@list) - 1) ; $i >= 0 ; $i--) {
    remote_exec_ignore ( "$node_ip", "echo y | $RPKGRM $optcmd -a /tmp/admin $list[$i]" ) ;
  }

  #
  # remove the admin file from the remote node
  #
  &remote_exec ( "$node_ip", "$RM /tmp/admin" ) ;

  # remove the local adminfile
  unlink ($admin_file) ;
}

#-------------------------------------------------------------------------------
#
# Install a package on a MEN 
#
# 1: Node ID
# 2: Package list
# 3: installed on 
#    . LOCAL:         /opt/SUNWcgha                 (basedir=default)
#    . SHARED:        /SUNWcgha/export/services     (basedir=/ha_v1/opt)
#    . SHARED_USR:    /export/Solaris_x             (basedir=/usr_sparc.all/usr/
#    . USR_SPECIFIC:  /export/Solaris_x             (basedir=/usr_sparc.all
# 4: answers file (null string if not required)
#
# if exists, the answers file is deleted before exiting !
#
#-------------------------------------------------------------------------------

sub install_men_pkg {

  my ($nodeid, $root_dir, $package_subdir, $package_list, $option, $answers_file) = @_;

  my $node_ip     = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${nodeid}";
  my $server_ip   = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${SERVER_NODE}";
  my $admin_file  = "$WORKING_DIR/admin";
  
  trace(3, "install_men_pkg: nodeid=$nodeid, root_dir=$root_dir, package_subdir=$package_subdir, package_list=$package_list, option=$option, answers_file=$answers_file") ;
  #
  #  configure settings
  #
  my $basedir = "default" ;
  my $dir     = "/opt/SUNWcgha" ;
  my $optcmd  = "" ;
  my $adj     = "" ;
  
  if ($option eq "LOCAL") {

    $basedir = "default" ;
    $dir     = "/opt/SUNWcgha" ;
    $optcmd  = "" ;
    $adj     = "local" ;

  } elsif ($option eq "SHARED") {

    $basedir = "/$OPT_SUBDIR" ;
    $dir     = "$SHARED_FS/$OPT_SUBDIR" ;
    $optcmd  = "-M -R $SHARED_FS" ;
    $adj     = "shared" ;

  } elsif ($option eq "SHARED_USR") {

    $loc = "/export/Solaris_8" ;
    if ($TARGET_OS eq "solaris_9") {
      $loc = "/export/Solaris_9" ;
    }
    $basedir = "/$USR_SUBDIR" ;
    $dir     = "$loc/$USR_SUBDIR" ;
    $optcmd  = "-M -R $loc" ;
    $adj     = "user" ;

  } elsif ( $option eq "USR_SPECIFIC") {

    $loc = "/export/Solaris_8" ;
    if ($TARGET_OS eq "solaris_9") {
      $loc = "/export/Solaris_9" ;
    }
    $basedir = "/$USR_SPECIFIC_SUBDIR" ;
    $dir     = "" ;
    $optcmd  = "-M -R $loc" ;
    $adj     = "usr-specific" ;

  } else {

    error("Invalid option ($option) for MEN package installation") ;
  }

  print_action("Installing $adj packages: $package_list ...") ;

  #
  # Test the product directory tree
  #
  &control_dir_is_readable ("$root_dir/$package_subdir");
  
  #
  # mount ROOT_DIR
  #   
  remote_mount($node_ip, $server_ip, $root_dir, "/mnt") ;
  
  # 
  # Create a pkgadd admin file
  #
  open(ADMIN, ">$admin_file") ||
    &error("Unable to create $admin_file");

   print ADMIN <<"FEO";
	
mail=
instance=overwrite
partial=nocheck
runlevel=quit
idepend=nocheck
rdepend=nocheck
space=quit
setuid=nocheck
conflict=nocheck
action=nocheck
basedir=$basedir

FEO


  close(ADMIN);
  
  #
  # copy the admin file on the remote node
  #
  &exec_cmd( "$RCP $admin_file $node_ip:/tmp/admin" ) ||
    &error ( "Unable to copy $admin_file on $node_ip:/tmp/admin") ;
  
  #
  # copy the answers file on the remote node
  #
  if ($answers_file ne "") {
    &exec_cmd( "$RCP $answers_file $node_ip:/tmp/answers" ) ||
	  &error ( "Unable to copy $answers_file on $node_ip:/tmp/answers") ;
  }

  #
  # Remotely create the install directory in case it is needed by BASE_DIR
  #
  if ($dir ne "") {
    &remote_exec ( "$node_ip", "$RMKDIR -p $dir" ) ||
      &error("Unable to create $dir directory needed by BASE_DIR package installation setup");
  }

  #
  # Install packages remotely
  #
  if ($answers_file eq "") {
    &remote_exec ( "$node_ip", "$RPKGADD -a /tmp/admin -d /mnt/$package_subdir $optcmd $package_list" ) ||
      &exit_install_pkg($admin_file, $answers_file, $node_ip);
  } else {
    &remote_exec ( "$node_ip", "$RPKGADD -a /tmp/admin -r /tmp/answers -d /mnt/$package_subdir $optcmd $package_list" ) ||
      &exit_install_pkg($admin_file, $answers_file, $node_ip);
  }
  
  #
  # remove the admin file from the remote node
  #
  &remote_exec ( "$node_ip", "$RM /tmp/admin" ) ||
    &exit_install_pkg($admin_file, $answers_file, $node_ip);
  
  #
  # remove the answers file from the remote node
  #
  if ($answers_file ne "") {
    &remote_exec ( "$node_ip", "$RM /tmp/answers" ) ||
      &exit_install_pkg($admin_file, $answers_file, $node_ip);
  }

  #
  # remove previously created pkgadd admin and answers file
  #
  &trace(1, "Succeeds to install packages");
  unlink($admin_file);
  if ($answers_file ne "") {
    unlink($answers_file);
  }

  #
  # umount ROOT_DIR
  #   
  &remote_exec ( "$node_ip", "$RUMOUNT /mnt" ) ||
    &error ( "Unable to NFS umount /mnt" );
}

#-------------------------------------------------------------------------------
#
# Remove packages for all NMENs on a MEN
#
# 1: Node ID
# 2: Package list
#
#-------------------------------------------------------------------------------

sub remove_nmen_pkg {

  my ($nodeid, $package_list) = @_;

  my $node_ip     = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${nodeid}";
  my $admin_file  = "$WORKING_DIR/admin";
  
  print_action("Remove packages for diskless nodes: $package_list ...") ;

  # 
  # Create a pkgrm admin file
  #
  open(ADMIN, ">$admin_file") ||
    &error("Unable to create $admin_file");
  
  $basedir="default" ;

   print ADMIN <<"FEO";
	
mail=
instance=overwrite
partial=nocheck
runlevel=quit
idepend=quit
rdepend=nocheck
space=quit
setuid=nocheck
conflict=nocheck
action=nocheck
basedir=$basedir

FEO


  close(ADMIN);
  
  #
  # copy the admin file on the remote node
  #
  &exec_cmd( "$RCP $admin_file $node_ip:/tmp/admin" ) ||
    &error ( "Unable to copy $admin_file on $node_ip:/tmp/admin") ;

  #
  # remove packages for all NMENs
  #
  for my $node (0..$#NODE_LIST) {

    if ($node ne $MEN1 && $node ne $MEN2) {

      $node_name_template = build_node_name($NODE_LIST[$node]{id}, "");
      $node_root = "/export/root/$node_name_template";

      print_subaction("for $node_name_template ...") ;
      #
      # remove the packages in the reverse order
      #
      # do not display error
      my @list = split(" ",$package_list) ;
      for (my $i = (scalar(@list) - 1) ; $i >= 0 ; $i--) {
	remote_exec_ignore ( "$node_ip", "echo y | $RPKGRM $optcmd -a /tmp/admin -R $node_root $list[$i]" ) ;
      }
    }
  }
  
  #
  # remove the admin file from the remote node
  #
  remote_exec ( "$node_ip", "$RM /tmp/admin" ) ;
  
  # remove previously created pkgadd admin file
  #
  unlink($admin_file);	
}

#-------------------------------------------------------------------------------
#
# Install a package for all NMENs on a MEN
#
# 1: Node ID
# 2: Package list
# 3: answers file (null string if not required)
#
# if exists, the answers file is deleted before exiting !
#
#-------------------------------------------------------------------------------

sub install_nmen_pkg {

  my ($nodeid, $root_dir, $package_subdir, $package_list, $answers_file) = @_;

  my $node_ip     = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${nodeid}";
  my $server_ip   = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${SERVER_NODE}";
  my $admin_file  = "$WORKING_DIR/admin";
  
  #
  # Test the product directory tree
  #
  &control_dir_is_readable ("$root_dir/$package_subdir");
  
  print_action("Installing packages for diskless nodes: $package_list ...") ;

  #
  # mount ROOT_DIR
  #   
  remote_mount($node_ip, $server_ip, $root_dir, "/mnt") ;
  
  # 
  # Create a pkgadd admin file
  #
  open(ADMIN, ">$admin_file") ||
    &error("Unable to create $admin_file");
  
  $basedir="default" ;

   print ADMIN <<"FEO";
	
mail=
instance=overwrite
partial=nocheck
runlevel=quit
idepend=nocheck
rdepend=nocheck
space=quit
setuid=nocheck
conflict=nocheck
action=nocheck
basedir=$basedir

FEO


  close(ADMIN);
  
  #
  # copy the admin file on the remote node
  #
  &exec_cmd( "$RCP $admin_file $node_ip:/tmp/admin" ) ||
    &error ( "Unable to copy $admin_file on $node_ip:/tmp/admin") ;
  
  #
  # copy the answers file on the remote node
  #
  if ($answers_file ne "") {
    &exec_cmd( "$RCP $answers_file $node_ip:/tmp/answers" ) ||
	  &error ( "Unable to copy $answers_file on $node_ip:/tmp/answers") ;
  }

  #
  # Install packages on all NMENs
  #
  foreach $node (0..$#NODE_LIST) {
    if ($node ne $MEN1 && $node ne $MEN2) {
      $node_name_template = build_node_name($NODE_LIST[$node]{id}, "");
      $node_root = "/export/root/$node_name_template";

      #
      # Remotely create the install directory in case it is needed by BASE_DIR
      #
      &remote_exec ( "$node_ip", "$RMKDIR -p $node_root/opt/SUNWcgha " ) ||
	&error("Unable to create $node_root/opt/SUNWcgha directory needed by BASE_DIR package installation setup");	
      print_subaction("for $node_name_template ...") ;
      #
      # Install packages remotely
      #
      if ($answers_file eq "") {
	&remote_exec ( "$node_ip", "$RPKGADD -a /tmp/admin -d /mnt/$package_subdir -M -R $node_root $package_list" ) ||
	  &exit_install_pkg($admin_file, $answers_file, $node_ip);
      } else {
	&remote_exec ( "$node_ip", "$RPKGADD -a /tmp/admin -r /tmp/answers -d /mnt/$package_subdir -M -R $node_root $package_list" ) ||
	  &exit_install_pkg($admin_file, $answers_file, $node_ip);
      }
    }
  } 

  
  #
  # remove the admin file from the remote node
  #
  &remote_exec ( "$node_ip", "$RM /tmp/admin" ) ||
    &exit_install_pkg($admin_file, $answers_file, $node_ip);
  
  #
  # remove the answers file from the remote node
  #
  if ($answers_file ne "") {
    &remote_exec ( "$node_ip", "$RM /tmp/answers" ) ||
      &exit_install_pkg($admin_file, $answers_file, $node_ip);
  }

  #
  # remove previously created pkgadd admin and answers file
  #
  &trace(1, "Succeeds to install packages");
  unlink($admin_file);
  if ($answers_file ne "") {
    unlink($answers_file);
  }

  #
  # umount ROOT_DIR
  #   
  &remote_exec ( "$node_ip", "$RUMOUNT /mnt" ) ||
    &error ( "Unable to NFS umount /mnt" );	
}

#===============================================================================
#
#    PATCH MANAGEMENT ROUTINES
#
#===============================================================================

#-------------------------------------------------------------------------------
#
# Create the prerequisites for patching shared packages
#
#-------------------------------------------------------------------------------

sub shared_patch_preparation {
  my $dir  = "var/sadm/system/admin" ;
  my $file = "INST_RELEASE" ;

  my $node_ip   ="${SUBNET0}.${CLUSTER}.${SUBNET1}.${NODE_ID}";

  print_action("Creating prerequisites for patching shared packages ...") ;

  #
  # Remotely create directory
  #
  remote_exec( $node_ip, "$RMKDIR -p $DIR_SUNWCGHA_EXPORTED/services/$dir" ) ||
    error ( "Unable to create $DIR_SUNWCGHA_EXPORTED/services/$dir" );

  #
  # Remotely copy file
  #
  remote_exec($node_ip, "$RCOPY /$dir/$file $DIR_SUNWCGHA_EXPORTED/services/$dir/$file") ||
    error ( "Unable to copy $file on $DIR_SUNWCGHA_EXPORTED/services/$dir/$file" );
}

#-------------------------------------------------------------------------------
#
#  clean up when a patch installation fails
#
#  1: node ip address
#
#-------------------------------------------------------------------------------

sub exit_install_patch {

  my ($node_ip) = @_;

  &remote_exec ( "$node_ip", "$RUMOUNT /mnt" );
  &error("Unable to install patch" );
}

#-------------------------------------------------------------------------------
#
# remove patch on a MEN
# 
#-------------------------------------------------------------------------------

sub remove_men_patch {

  my ($node_id, $patch, $option) = @_;

  my $node_ip     = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${node_id}";
  my $server_ip   = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${SERVER_NODE}";
  my $optcmd ;
  my $adj ;

  my $patchid = $patch;
  if (substr($patch,0,1) eq "T") {
    # it's a temporary patch, remove the T to have the patch ID
    $patchid = substr($patch,1,length($patch)-1);
  }

  if ($option eq "LOCAL") {
    $optcmd = "" ;
    $adj = "local" ;
  } elsif ($option eq "SHARED") {
    $optcmd = "-R $SHARED_FS" ;
    $adj = "shared" ;
  } else {
    error("Invalid option ($option) for MEN patch installation") ;
  }
  print_action("Removing $adj patch: $patch ...") ;	
		
  #
  # Remove patch remotely
  #
  &remote_exec_ignore ( "$node_ip", "$RPATCHRM $optcmd $patchid" ) ;
   
  &trace(1, "Succeeds to remove $patch patch");
}

#-------------------------------------------------------------------------------
#
# install patch on a MEN
# 
#-------------------------------------------------------------------------------

sub install_men_patch {

  my ($node_id, $root_dir, $patch_subdir, $patch, $option) = @_;

  my $node_ip     = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${node_id}";
  my $server_ip   = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${SERVER_NODE}";
  my $optcmd ;
  my $adj ;

  if ($option eq "LOCAL") {
    $optcmd = "" ;
    $adj = "local" ;
  } elsif ($option eq "SHARED") {
    $optcmd = "-R $SHARED_FS" ;
    $adj = "shared" ;
  } else {
    error("Invalid option ($option) for MEN patch installation") ;
  }

  print_action("Installing $adj patch: $patch ...") ;

  #
  # Test the product directory tree
  #
  &control_dir_is_readable ("$root_dir/$patch_subdir");

  #
  # mount ROOT_DIR
  #   
  remote_mount($node_ip, $server_ip, $root_dir, "/mnt") ;
		
  #
  # Add patch remotely
  #
  &remote_exec ( "$node_ip", "$RPATCHADD -M /mnt/$patch_subdir $optcmd $patch" ) ||
    &exit_install_patch($node_ip);
   
  &trace(1, "Succeeds to add $patch patch");
   
  #
  # umount ROOT_DIR
  #   
  &remote_exec ( "$node_ip", "$RUMOUNT /mnt" ) || 
    &error ( "Unable to NFS umount /mnt" );
}

#-------------------------------------------------------------------------------
#
# remove a patch for all NMENs on a MEN
# 
#-------------------------------------------------------------------------------

sub remove_nmen_patch {

  my ($node_id, $patch, $where) = @_;

  my $node_ip     = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${node_id}";
  my $server_ip   = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${SERVER_NODE}";
   
  print_action("Removing patch for diskless nodes: $patch ...") ;
		
  if (($where ne "SOLARIS") && ($where ne "DISKLESS")) {
    error("internal error: install_nmen_patch location: $where (SOLARIS or DISKLESS required)");
  }
  
  my $patchid = $patch;
  if (substr($patch,0,1) eq "T") {
    # it's a temporary patch, remove the T to have the patch ID
    $patchid = substr($patch,1,length($patch)-1);
  }

  if ($where eq "SOLARIS") {
    #
    # Remove patch from Solaris environment remotely
    #
    $os = "Solaris_8" ;
    # TARGET_OS may be not defined (default is Solaris 8)
    if ($TARGET_OS eq "Solaris_9") {
      $os = "Solaris_9" ;
    }

    print_subaction("for $os service ...") ;
    &remote_exec_ignore ( "$node_ip", "$RPATCHRM -S $os $patchid" ) ;

  } else {

    #
    # Remove patches from diskless nodes remotely
    #
    for my $node (0..$#NODE_LIST) {
      if ($node ne $MEN1 && $node ne $MEN2) {
	$node_name_template = build_node_name($NODE_LIST[$node]{id}, "");
	$node_root = "/export/root/$node_name_template";
	
	print_subaction("for $node_name_template ...") ;
	
	&remote_exec_ignore ( "$node_ip", "$RPATCHRM -R $node_root $patchid" ) ;
      }
    }
  }

  &trace(1, "Succeeds to remove $patch patch");
}

#-------------------------------------------------------------------------------
#
# install patch for all NMENs on a MEN
# 
#-------------------------------------------------------------------------------

sub install_nmen_patch {

  my ($node_id, $root_dir, $patch_subdir, $patch, $where) = @_;

  my $node_ip     = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${node_id}";
  my $server_ip   = "${SUBNET0}.${CLUSTER}.${SUBNET1}.${SERVER_NODE}";
   
  print_action("Installing patch for diskless nodes: $patch ...") ;

  #
  # Test the product directory tree
  #
  &control_dir_is_readable ("$root_dir/$patch_subdir");

  #
  # mount ROOT_DIR
  #
  remote_mount($node_ip, $server_ip, $root_dir, "/mnt") ;

  if (($where ne "SOLARIS") && ($where ne "DISKLESS")) {
    error("internal error: install_nmen_patch location: $where (SOLARIS or DISKLESS required)");
  }

  if ($where eq "SOLARIS") {

    #
    # Add patch on Solaris environment remotely
    #
    $os = "Solaris_8" ;
    # TARGET_OS may be not defined (default is Solaris 8)
    if ($TARGET_OS eq "Solaris_9") {
      $os = "Solaris_9" ;
    }
    
    print_subaction("for $os service ...") ;
    &remote_exec ( "$node_ip", "$RPATCHADD -M /mnt/$patch_subdir -S $os $patch" ) ||
      &exit_install_patch($node_ip);

  } else {

    #
    # Install patches on diskless nodes remotely
    #
    for my $node (0..$#NODE_LIST) {
      if ($node ne $MEN1 && $node ne $MEN2) {
	$node_name_template = build_node_name($NODE_LIST[$node]{id}, "");
	$node_root = "/export/root/$node_name_template";
	
	print_subaction("for $node_name_template ...") ;
	
	&remote_exec ( "$node_ip", "$RPATCHADD -R $node_root -M /mnt/$patch_subdir $patch" ) ||
	  &exit_install_patch($node_ip);
      }
    }
  }

  &trace(1, "Succeeds to add $patch patch");
   
  #
  # umount ROOT_DIR
  #   
  &remote_exec ( "$node_ip", "$RUMOUNT /mnt" ) || 
    &error ( "Unable to NFS umount /mnt" );
}

#===============================================================================
#
# HANDLING OF NODE NAMES AND RELATED FILES
#
#===============================================================================

#-------------------------------------------------------------------------------
#
# build the server name
#
#-------------------------------------------------------------------------------

sub build_server_name {
 
  return "sar-c${CLUSTER}-n${SERVER_NODE}" ;
}

#-------------------------------------------------------------------------------
#
# look for a node by its nodeid
#
#-------------------------------------------------------------------------------

sub getnode
  {
    my ($node_id) = @_ ;

    for my $i (0..$#NODE_LIST) {
      if ($NODE_LIST[$i]{id} eq $node_id) {
	return $i;
      }
    }

    error("Internal error: getnode: $node_id can't be reached\n");
  }

#-------------------------------------------------------------------------------
#
# build the node name depending on the node ID
#
#-------------------------------------------------------------------------------

sub build_node_name {
 
  my ($nodeid, $interface) = @_ ;

  my $name = "";

  if ($nodeid eq $MASTER_ID) {
    $name = "master" ;
  } elsif ($nodeid eq $VICEMASTER_ID) {
    $name = "vice-master" ;
  } else {
    my $hostname = $NODE_LIST[getnode($nodeid)]{name};
    
    if (($hostname ne "") && ($hostname ne "-")) {
      $name = $hostname ;
    } else {
      if (($nodeid eq $NODE_LIST[$MEN1]{id}) || ($nodeid eq $NODE_LIST[$MEN2]{id})) {
	$name = "MEN-C${CLUSTER}-N${nodeid}" ;
      } else {
	$name = "NMEN-C${CLUSTER}-N${nodeid}" ; 
      }
    }
  }

  my $post = "" ;
  if ($intercace eq "") {
    $post = "" ;
  }
  if ($interface eq "NIC0") {
    $post = $POST_NIC0 ;
  }
  if ($interface eq "NIC1") {
    $post = $POST_NIC1 ;
  }
  if ($interface eq "CGTP") {
    $post = $POST_CGTP ;
  }

  $name = $name . $post ;

  return $name ;
}

#-------------------------------------------------------------------------------
#
# updating an host entry
#
# . look for the entry based on the IP address
# . when found, add each alias that are not yet defined and keep the already
#   alias and entries
#
#-------------------------------------------------------------------------------

sub update_hosts_entry {

  my ($hosts_file, $host_ip, $alias_list) = @_;
  my $found_host = FALSE ;
  my $found_alias = FALSE;

  #
  # look for the entry
  #

  open(HOSTS, "<$hosts_file");
  open(HOSTS_TMP, ">$hosts_file.tmp");
  while (<HOSTS>) {
    chomp();
    s/#.*//;

    # is it a valid host entry ?
    $line = $_;
    if ($line =~ m/([0-9]*.[0-9]*.[0-9]*.[0-9]*)[\s\t]*(.*)/) {

      # $1: IP addresse
      # $2: aliases list

      # look for the searched one
      if ($1 eq $host_ip) {
	$found_host = TRUE;

	# check for all required aliases and add the missing ones

	foreach my $expected_alias (split(/[\s\t]+/,$alias_list)) {
	  $found_alias = FALSE;

	  foreach my $current_alias (split(/[\s\t]+/,$2)) {
	    if ($expected_alias eq $current_alias) {
	      $found_alias = TRUE;
	    }
	  }

	  # add the alias when not found
	  if ($found_alias eq FALSE) {
	    $line .= " $expected_alias";
	  }
	}
      }
      # copy the host entry (the same entry or the update one)
      print HOSTS_TMP "$line\n";
    }
  }

  if ($found_host eq FALSE) {
    # add the entry
    print HOSTS_TMP "$host_ip $alias_list\n";
  }

  close (HOSTS);
  close (HOSTS_TMP);

  # move the temporary file on the final one
  exec_cmd ("$MV $hosts_file.tmp $hosts_file");
  }

#-------------------------------------------------------------------------------
#
#  update the local hosts file before transferring
#
#-------------------------------------------------------------------------------

sub update_hosts_file
  {
    
    my ($hosts_file, $current_node) = @_ ;

    my $node_ip_if0_template;
    my $node_ip_if1_template;
    my $node_ip_cgtp0_template;
    
    my $node_name_template;
    my $node_name_if0_template;
    my $node_name_if1_template;
    my $node_name_cgtp0_template;
    
    my $master_name_if0 = build_node_name($MASTER_ID, "NIC0");
    my $master_name_if1 = build_node_name($MASTER_ID, "NIC1");
    my $master_name_cgtp0 = build_node_name($MASTER_ID, "CGTP");
    my $master_ip_if0 = "$SUBNET0.$CLUSTER.$SUBNET1.$MASTER_ID" ;
    my $master_ip_if1 = "$SUBNET0.$CLUSTER.$SUBNET2.$MASTER_ID" ;
    my $master_ip_cgtp0 = "$SUBNET0.$CLUSTER.$SUBNET3.$MASTER_ID" ;

    my $vice_master_name_if0 = build_node_name($VICEMASTER_ID, "NIC0") ;
    my $vice_master_name_if1 = build_node_name($VICEMASTER_ID, "NIC1");
    my $vice_master_name_cgtp0 = build_node_name($VICEMASTER_ID, "CGTP");
    my $vice_master_ip_if0 = "$SUBNET0.$CLUSTER.$SUBNET1.$VICEMASTER_ID" ;
    my $vice_master_ip_if1 = "$SUBNET0.$CLUSTER.$SUBNET2.$VICEMASTER_ID" ;
    my $vice_master_ip_cgtp0 = "$SUBNET0.$CLUSTER.$SUBNET3.$VICEMASTER_ID" ;
    
    my $loghost= "loghost" ;
    my $alias_list = "";
    
    for my $node (0..$#NODE_LIST) {
      my $node_id = $NODE_LIST[$node]{id};
      $node_ip_if0_template   ="$SUBNET0.$CLUSTER.$SUBNET1.${node_id}";
      $node_ip_if1_template = "$SUBNET0.$CLUSTER.$SUBNET2.${node_id}";
      $node_ip_cgtp0_template = "$SUBNET0.$CLUSTER.$SUBNET3.${node_id}";
      
      $node_name_template = build_node_name($node_id, "") ;
      $node_name_if0_template = build_node_name($node_id, "NIC0") ;   
      $node_name_if1_template = build_node_name($node_id, "NIC1") ;
      $node_name_cgtp0_template= build_node_name($node_id, "CGTP") ;


      #
      # for diskless, a alias with the generic name must be created for the nic0 interface (must be the first)
      # to avoid a failure while smdiskless is executing
      #

      if ($node_id eq $current_node) {
	# add a name without postfix for nic 0 if no postfix is empty (required for smdiskless)
	$alias_list = "$node_name_if0_template $node_name_template.$DOMAIN $node_name_if0_template.$DOMAIN $loghost" ;
	if (($POST_NIC0 ne "") && ($POST_NIC1 ne "") && ($POST_CGTP ne "")) {
	  $alias_list = "$node_name_template $alias_list" ;
	} else {
	  $alias_list = "$node_name_if0_template $node_name_template.$DOMAIN $node_name_if0_template.$DOMAIN $loghost\n" ;
	}

	update_hosts_entry($hosts_file, $node_ip_if0_template, $alias_list);

	if ($USE_CGTP eq "YES") {
	  $alias_list = "$node_name_if1_template $node_name_if1_template.$DOMAIN" ;
	  update_hosts_entry($hosts_file, $node_ip_if1_template, $alias_list);
	  
	  $alias_list = "$node_name_cgtp0_template $node_name_cgtp0_template.$DOMAIN" ;
	  update_hosts_entry($hosts_file, $node_ip_cgtp0_template, $alias_list);
	}
      } else {
	if (($POST_NIC0 ne "") && ($POST_NIC1 ne "") && ($POST_CGTP ne "")) {
	  $alias_list = "$node_name_template $node_name_if0_template" ;
	} else {
	  $alias_list = "$node_name_if0_template" ;
	}
	update_hosts_entry($hosts_file, $node_ip_if0_template, $alias_list);
	if ($USE_CGTP eq "YES") {
	  $alias_list = "$node_name_if1_template" ;
	  update_hosts_entry($hosts_file, $node_ip_if1_template, $alias_list);
	  $alias_list = "$node_name_cgtp0_template" ;
	  update_hosts_entry($hosts_file, $node_ip_cgtp0_template, $alias_list);
	}
      }
    }
    
    update_hosts_entry($hosts_file, $master_ip_if0, "$master_name_if0") ;
    if ($USE_CGTP eq "YES") {
      update_hosts_entry($hosts_file, $master_ip_if1, "$master_name_if1") ;
      update_hosts_entry($hosts_file, $master_ip_cgtp0, "$master_name_cgtp0");
    }
    
    update_hosts_entry($hosts_file, $vice_master_ip_if0, "$vice_master_name_if0") ;
    if ($USE_CGTP eq "YES") {
      update_hosts_entry($hosts_file, $vice_master_ip_if1, "$vice_master_name_if1") ;
      update_hosts_entry($hosts_file, $vice_master_ip_cgtp0,"$vice_master_name_cgtp0") ;
    }
  }

#-------------------------------------------------------------------------------
#
#  create the local hosts file before transferring
#
#-------------------------------------------------------------------------------

sub create_hosts_file
  {
    
    my ($hosts_file, $current_node) = @_ ;

    my $node_ip_if0_template;
    my $node_ip_if1_template;
    my $node_ip_cgtp0_template;
    
    my $node_name_template;
    my $node_name_if0_template;
    my $node_name_if1_template;
    my $node_name_cgtp0_template;
    
    my $master_name_if0 = build_node_name($MASTER_ID, "NIC0");
    my $master_name_if1 = build_node_name($MASTER_ID, "NIC1");
    my $master_name_cgtp0 = build_node_name($MASTER_ID, "CGTP");
    my $master_ip_if0 = "$SUBNET0.$CLUSTER.$SUBNET1.$MASTER_ID" ;
    my $master_ip_if1 = "$SUBNET0.$CLUSTER.$SUBNET2.$MASTER_ID" ;
    my $master_ip_cgtp0 = "$SUBNET0.$CLUSTER.$SUBNET3.$MASTER_ID" ;

    my $vice_master_name_if0 = build_node_name($VICEMASTER_ID, "NIC0") ;
    my $vice_master_name_if1 = build_node_name($VICEMASTER_ID, "NIC1");
    my $vice_master_name_cgtp0 = build_node_name($VICEMASTER_ID, "CGTP");
    my $vice_master_ip_if0 = "$SUBNET0.$CLUSTER.$SUBNET1.$VICEMASTER_ID" ;
    my $vice_master_ip_if1 = "$SUBNET0.$CLUSTER.$SUBNET2.$VICEMASTER_ID" ;
    my $vice_master_ip_cgtp0 = "$SUBNET0.$CLUSTER.$SUBNET3.$VICEMASTER_ID" ;
    
    my $loghost= "loghost" ;
    
    open (HOSTS, ">$hosts_file" ) || &error("Unable to open $hosts_file");
    print HOSTS "127.0.0.1 localhost\n" ;
    
    for my $node (0..$#NODE_LIST) {
      my $node_id = $NODE_LIST[$node]{id};
      $node_ip_if0_template   ="$SUBNET0.$CLUSTER.$SUBNET1.${node_id}";
      $node_ip_if1_template = "$SUBNET0.$CLUSTER.$SUBNET2.${node_id}";
      $node_ip_cgtp0_template = "$SUBNET0.$CLUSTER.$SUBNET3.${node_id}";
      
      $node_name_template = build_node_name($node_id, "") ;
      $node_name_if0_template = build_node_name($node_id, "NIC0") ;   
      $node_name_if1_template = build_node_name($node_id, "NIC1") ;
      $node_name_cgtp0_template= build_node_name($node_id, "CGTP") ;

      #
      # for diskless, a alias with the generic name must be created for the nic0 interface (must be the first)
      # to avoid a failure while smdiskless is executing
      #
      if ($node_id eq $current_node) {
	# add a name without postfix for nic 0 if no postfix is empty (required for smdiskless)
	if (($POST_NIC0 ne "") && ($POST_NIC1 ne "") && ($POST_CGTP ne "")) {
	  print HOSTS "$node_ip_if0_template $node_name_template $node_name_if0_template $node_name_template.$DOMAIN $node_name_if0_template.$DOMAIN $loghost\n" ;
	} else {
	  print HOSTS "$node_ip_if0_template $node_name_if0_template $node_name_template.$DOMAIN $node_name_if0_template.$DOMAIN $loghost\n" ;
	}

	if ($USE_CGTP eq "YES") {
	  print HOSTS "$node_ip_if1_template $node_name_if1_template $node_name_if1_template.$DOMAIN\n" ;
	  print HOSTS "$node_ip_cgtp0_template $node_name_cgtp0_template $node_name_cgtp0_template.$DOMAIN\n" ;
	}
      } else {
	if (($POST_NIC0 ne "") && ($POST_NIC1 ne "") && ($POST_CGTP ne "")) {
	  print HOSTS "$node_ip_if0_template $node_name_template $node_name_if0_template\n" ;
	} else {
	  print HOSTS "$node_ip_if0_template $node_name_if0_template\n" ;
	}
	if ($USE_CGTP eq "YES") {
	  print HOSTS "$node_ip_if1_template $node_name_if1_template\n" ;
	  print HOSTS "$node_ip_cgtp0_template $node_name_cgtp0_template\n" ;
	}
      }
    }
    
    print HOSTS "$master_ip_if0 $master_name_if0\n" ;
    if ($USE_CGTP eq "YES") {
      print HOSTS "$master_ip_if1 $master_name_if1\n" ;
      print HOSTS "$master_ip_cgtp0 $master_name_cgtp0\n" ;
    }

    print HOSTS "$vice_master_ip_if0 $vice_master_name_if0\n" ;
    if ($USE_CGTP eq "YES") {
      print HOSTS "$vice_master_ip_if1 $vice_master_name_if1\n" ;
      print HOSTS "$vice_master_ip_cgtp0 $vice_master_name_cgtp0\n" ;
    }
    close (HOSTS);
  }

#===============================================================================
#
#  ARGUMENT PROCESSING
#
#===============================================================================

#-------------------------------------------------------------------------------
#
#  check if an argument is in a list
#
#  proces the list of variables to be updated and check if the argument refers
#  to one of these variables
#
#-------------------------------------------------------------------------------

sub check_arg {

  ($list, $arg) = @_ ;

  foreach $variable (@$list) {
    if (($ARGLST{$variable}[$ARGSHORT] eq $arg) || ($ARGLST{$variable}[$ARGLONG] eq $arg)) {
      return $variable ;
    }
  }
  return "" ;
}

#-------------------------------------------------------------------------------
#
# read the arguments
#
#-------------------------------------------------------------------------------

sub init_and_read_arg {

  ($caller,$required, $optional) = @_ ;

  if ($ENV{NH_LOG_FILE} ne "") {
    $LOGFILE_NAME=$ENV{NH_LOG_FILE} ;
    $IN_LOGFILE = TRUE ;
  }

  load_conf ;

  # reset variables
  foreach $variable (@$required) {
    $$variable = "" ;
  }
  foreach $variable (@$optional) {
    $$variable = "" ;
  }

  for (my $i=0; $i <= $#ARGV; $i++) {
    if ($ARGV[$i] eq '-z' | $ARGV[$i] eq '--recovery') {
      $RECOVERY=$ARGV[++$i] ;
    } elsif    ($ARGV[$i] eq '-d' | $ARGV[$i] eq '--debug') {
      $VERBOSE++ ;
    } elsif ($ARGV[$i] eq '-h' | $ARGV[$i] eq '--help' ) {
      usage($caller,$required, $optional); 
      exit(0)
    } else {
      $variable = check_arg($required, $ARGV[$i]) ;
      if ($variable ne "") {
	$$variable = $ARGV[++$i] ;
      } else {
	$variable = check_arg($optional, $ARGV[$i]) ;
	if ($variable ne "") {
	  $$variable = $ARGV[++$i] ;
	} else {
	  print_log( "$ARGV[$i]: Unknown argument\n") ;
	  usage($caller, $required, $optional);
	  exit 1 ;
	}
      } 
    }
  }

  # check that required arguments are presents
  foreach $variable (@$required) {
    if (! defined($$variable)) {
      print_log("$variable is required\n") ;
      usage($caller,$required,$optional) ;
      exit 1 ;
    } else {
      if ($variable eq "NODE_ROLE") {
	if ($NODE_ROLE eq "m") {
	  $NODE_ID = $MASTER_ID ;
	} elsif ($NODE_ROLE eq "v") {
	  $NODE_ID = $VICEMASTER_ID ;
	} elsif (($NODE_ROLE !~ /^\d+$/) 
		 || ($NODE_ROLE <= 0) 
		 || ($NODE_ROLE >= 3)) {
	  print_log("$variable is invalid (1, 2, m or v)\n") ;
	  usage($caller, $required, $optional) ;
	  exit 1
	} else {
	  if ( $NODE_ROLE eq 1 ) {
	    $NODE_ID = $NODE_LIST[$MEN1]{id} ;
	  } else {
	    $NODE_ID = $NODE_LIST[$MEN2]{id} ;
	  }
	}
      }
    }
  }

  init() ;
}


#-------------------------------------------------------------------------------
#
# usage
#
#-------------------------------------------------------------------------------

sub usage {

  ($caller, $required, $optional) = @_;

  print_log("Usage: $caller\n") ;
  print_log("       -h\|--help this help\n") ;
  print_log("\n") ;
  print_log("Usage: $caller\n") ;
  foreach $variable (@$required) {
    print_log("       $ARGLST{$variable}[$ARGSHORT]|$ARGLST{$variable}[$ARGLONG] $ARGLST{$variable}[$ARGDESC]\n") ;
}
  foreach $variable (@$optional) {
    print_log("       \[ $ARGLST{$variable}[$ARGSHORT]|$ARGLST{$variable}[$ARGLONG] \] $ARGLST{$variable}[$ARGDESC]\n") ;
  }
  
  print_log("       [ -d|--debug [-d|--debug] [-d|--debug] ... ]\n") ;
  print_log("\n") ;
  print_log("Specifying multiple -d options increase level of verbosity\n") ;
}
